--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_pf.c	2012-08-08 12:41:59.586868818 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_pf.c	2012-08-08 12:41:59.633375512 +0000
@@ -153,6 +153,8 @@
 	{IPPROTO_ESP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{-1, 0, 0}	/* must be the final entry */
 };
 
@@ -187,6 +189,10 @@
 	    IPV4_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, (DL_IPNETINFO_VERSION << 8 | AF_INET6),
 	    IPV6_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, (DL_IPNETINFO_VERSION << 8 | AF_INET),
+	    IPV4_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, (DL_IPNETINFO_VERSION << 8 | AF_INET6),
+	    IPV6_TYPE_HEADER_OFFSET},
 	{-1, 0, 0}	/* must be the final entry */
 };
 
@@ -206,6 +212,8 @@
 	{IPPROTO_ESP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{-1, 0, 0}	/* must be the final entry */
 };
 
@@ -1328,6 +1336,13 @@
 			break;
 		}
 
+		if (EQ("dccp")) {
+			pf_check_transport_protocol(IPPROTO_DCCP);
+			opstack++;
+			next();
+			break;
+		}
+
 		if (EQ("(")) {
 			inBrace++;
 			next();
